package src;

/*  21 gennaio 2019 */

class LungArrayDiffExc extends Exception { }

// metodo iterativo 

public static String[] mi (String[][] a, int[] b) throws LungArrayDiffExc {
  if (a.length != b.length) throw new LungArrayDiffExc();
  String[] c = new String[a.length];
  for (int i=0; i<a.length; i++) {
    c[i] = "";
    int j = 0; boolean trovato = false;
    while (j<a[i].length && !trovato) {
      if (a[i][j].length() > b[i]) {
        c[i] = a[i][j];
        trovato = true;
      }
      j++;
    }
  }
  return c;
}

// metodo ricorsivo 

public static String[] mR (String[][] a, int[] b) throws LungArrayDiffExc {
  if (a.length != b.length) throw new LungArrayDiffExc();
  String[] c = new String[a.length];
  return mR(a,b,c,0,0);
}

public static String[] mR (String[][] a, int[] b, String[] c, int i, int j) {
  if (i==a.length) return c;
  if (j==0) c[i] = "";
  if (j==a[i].length) {
    return mR(a,b,c,i+1,0);
  }
  if (a[i][j].length() > b[i]) {
    c[i] = a[i][j];
    return mR(a,b,c,i+1,0);
  }
  return mR(a,b,c,i,j+1);
}






