class TragittoT {

    private String stazionePartenza;
    private String stazioneArrivo;
    private int numeroTreno;
    private String tipologiaTreno;
    private double distanzaPercorsa;
    private int orarioPartenza;
    private int orarioArrivo;

    public TragittoT(String stazionePartenza, String stazioneArrivo, int numeroTreno,
              String tipologiaTreno, double distanzaPercorsa, int orarioPartenza,
              int orarioArrivo) {
        this.stazionePartenza = stazionePartenza;
        this.stazioneArrivo = stazioneArrivo;
        this.numeroTreno = numeroTreno;
        this.tipologiaTreno = tipologiaTreno;
        this.distanzaPercorsa = distanzaPercorsa;
        this.orarioPartenza = orarioPartenza;
        this.orarioArrivo = orarioArrivo;
    }

    public String getStazionePartenza() {
        return this.stazionePartenza;
    }

    public String getStazioneArrivo() {
        return this.stazioneArrivo;
    }

    public int getNumeroTreno() {
        return this.numeroTreno;
    }

    public String getTipologiaTreno() {
        return this.tipologiaTreno;
    }

    public double getDistanzaPercorsa() {
        return this.distanzaPercorsa;
    }

    public int getOrarioPartenza() {
        return this.orarioPartenza;
    }

    public int getOrarioArrivo() {
        return this.orarioArrivo;
    }

    public void setTipologia(String tipologia) {
        this.tipologiaTreno = tipologia;
    }

    public boolean stessaStazione(TragittoT s) {

        if (this.getStazionePartenza().equals(s.getStazionePartenza()) &&
                this.getStazioneArrivo().equals(s.getStazioneArrivo()))
            return true;
        else
            return false;
    }

    public TragittoT maxStazione(TragittoT s) {

        if (this.getDistanzaPercorsa() > s.getDistanzaPercorsa())
            return this;
        else
            return s;
    }

    public String toString(TragittoT t) {
        return "Stazione di Partenza: "+this.getStazionePartenza()+" --> "+"Stazione di Arrivo: "+this.getStazioneArrivo()+"\n"+"Numero del trento: "+this.getNumeroTreno()+
                "\n Tipologia di Treno: "+this.getTipologiaTreno()+ "\n Distanza Percorsa: "+this.getDistanzaPercorsa()+" Orario di Partenza: "+this.getOrarioPartenza()+" Orario di Arrivo: "+this.getOrarioArrivo();
    }



}


