class StazioniPartenzeDiverse extends Exception { }

class ElencoPieno extends Exception { }

class OrarioP {

    private String nomeStazione;
    private int annoValidita;

    private TragittoT[] t;

    private int c = 0;


    public OrarioP(String nomeStazione, int annoValidita, int max) {

        this.nomeStazione = nomeStazione;
        this.annoValidita = annoValidita;
        t = new TragittoT[max];
    }

    public String getNomeStazione() {
        return this.nomeStazione;
    }

    public int getAnnoValidita() {
        return this.annoValidita;
    }



    public void aggiungiTreno(TragittoT tr) throws StazioniPartenzeDiverse, ElencoPieno {


        if (this.c == this.t.length)
            throw new ElencoPieno();

        if (this.nomeStazione.equals(tr.getStazionePartenza())) {
            t[c] = tr;
            c++;
        }
        else
            throw new StazioniPartenzeDiverse();



    }

    public TragittoT[] partenzeDopo(int k) {

        int count = 0;
        int j = 0;
        TragittoT[] tragitti;

        for (int i = 0; i < this.c; i++) {

            if(this.t[i].getOrarioPartenza() > k)
                count++;
        }

        tragitti = new TragittoT[count];

        for (int i = 0; i < this.c; i++) {
            if(this.t[i].getOrarioPartenza() > k) {
                tragitti[i] = t[j];
                j++;
            }

        }

        return tragitti;
    }


    public int tragittiTrenoStazioneArrivo(String s) {

        int count = 0;

        for (int i = 0; i < this.c; i++) {

            if (this.t[i] instanceof TragittoTPren &&
                    this.t[i].getStazioneArrivo().equals(s))
                count++;
        }
        return count;
    }


}